﻿using System;
using System.Net;
using System.Text;
using System.Security;
using System.Collections.Generic;
using System.Windows.Media.Imaging;
using System.Windows.Browser;
using System.Windows;
using System.Windows.Resources;
using System.Windows.Controls;
using System.Data;
using SL_ACO;
using SL_ACO.ACO;
using System.IO;
using System.IO.IsolatedStorage;

namespace SL_ACO.ACO
{
    internal class Izlaz
    {
        #region Fields

        private string data;

        #endregion

        #region Methods

        /// <summary>
        /// konstruktor, stvara podatke o trenutnom problemu te tive private metodu da ih 
        /// zapise u datoteku imenom path
        /// </summary>
        /// <param name="path">ime datoteke u koju spremat podatke</param>
        internal Izlaz(string ImeFilea)
        {
            string Output = "";
            if (AntColony.Instance.Get_tip() == tipProblema.TSP)
            {
                Output += "TSP" + '\r' + '\n';
            }
            if (AntColony.Instance.Get_tip() == tipProblema.VRP)
            {
                Output += "VRP" + '\r' + '\n';
                string brojVozilaString = AntColony.Instance.Get_brojVozila().ToString();
                Output += "!vozila" + brojVozilaString + '\r' + '\n';
            }
            foreach (Grad g in AntColony.Instance.gradovi)
            {
                if (g != null)
                {
                    if ((g.get_x() != 0) || (g.get_y() != 0))
                    {
                        string XString = g.get_x().ToString();
                        Output += XString + ' ';
                        string YString = g.get_y().ToString();
                        Output += YString + '\r' + '\n';
                    }
                }
            }
            this.data = Output;
            this.StoreIsolatedFile(ImeFilea);
            return;
        }

        /// <summary>
        /// zapisivanje this.data u UserStoreForApplication\path
        /// </summary>
        /// <param name="path">path</param>
        private void StoreIsolatedFile(string path)
        {
            try
            {
                IsolatedStorageFile iso = IsolatedStorageFile.GetUserStoreForApplication();
                using (IsolatedStorageFileStream isoStream = new IsolatedStorageFileStream(path, FileMode.Create, iso))
                {
                    using (StreamWriter writer = new StreamWriter(isoStream))
                    {
                        writer.Write(this.data);
                        MessageBox.Show("Datoteka spremljena! " +path);
                    }
                }
            }
            catch
            {
                MessageBox.Show("Nemogu spremiti datoteku! nedostatak mjesta u direktoruji ili nedostupan prostor.");
            }
        }

        #endregion
    }
}
